// Kozak's Jisho v2.4 - Kana Kanji henkan engine by N's LAB Copyright (C) 2006 by Nobumichi Kozawa
import javax.microedition.io.*;
import javax.microedition.rms.*;
//import javax.microedition.lcdui.*;
import javax.microedition.io.file.*;
import java.io.*;

public class Jisho
{
    private String sFileName;
    private String sWord, sRemain;
    private byte[] indexCache;
    private String[] wordCache;
    private String[] contCache;
    private byte[] hashCache;
    private boolean[] stCache;
    private int iCachePos;
    private String[] wordUdic;
    private String[] contUdic;
    private byte[] hashUdic;
    private int iNumUdic = 100;
    private boolean bCacheMode = true;
    private boolean bNeedOpenDic = true;
    private boolean bFirstV = false;
    public boolean bCN = false;
    private int idx;
    private Vect v, vCurrent, vBase;
    private char cIni;
    private String sPre = "";
    public String sError;
    public StringBuffer sbDebug;
    public static byte dicVersion = 3;
    public static byte dicType = 0; // 0 - M, 1 - ML .... no longer needed :)
    private InputStream in = null;
    private InputStreamReader isn = null;
    private static String enc = "UTF-8";    // Cache has to be enc/dec in UTF-8
    public int iCacheHit, iTotalHit;
    public static int iNumCacheEntries = 128;
    public static int iNumStCache = 16;        // Number of sticky cache entries
    public static int iCacheSize = 2560;
    private static String sSetuzokusi = "てにをはともをがでの";
    public boolean bLoadIndex;
    public String sUdicErr = null;

    public Jisho()
    {
        v = new Vect();
        idx = -1;
        setDictName();
        sError = "";
        if (!(bLoadIndex = loadIndex())) {
            storeIndex();
        }
        KKJConv.bCN = bCN;
/*        else {
            if (KKJConv.bCN && !bCN) {
                bCN = true;
                if (indexJisho(sFileName)) storeIndex();
            }
        }*/
//        sbDebug = new StringBuffer();
        if (1 == KKJConv.bUserDict) loadUdic();
        else iNumUdic = 0;
        cacheInit();
    }

    private void setDictName()
    {
        sFileName = "/SKK-JISYO.M";
        in = getClass().getResourceAsStream(sFileName);
        if (null == in) {
            sFileName = "/SKK-JISYO.MML";
            in = getClass().getResourceAsStream(sFileName);
            if (null == in) {
                sFileName = "/SKK-JISYO.L";
                in = getClass().getResourceAsStream(sFileName);
            }
        }
        try {
            if (null == in) sError = "Dictionary Resource Open Failure.";
            else in.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
        in = null;
    }

    private void cacheInit()
    {
        iCacheHit = iTotalHit = 0;
        indexCache = new byte[iNumCacheEntries];
        hashCache = new byte[iNumCacheEntries];
        wordCache = new String[iNumCacheEntries];
        contCache = new String[iNumCacheEntries];
        stCache = new boolean[iNumCacheEntries];
        for (int i = 0; i < iNumCacheEntries; i++) {
            indexCache[i] = (byte)i;
            hashCache[i] = 0;
            stCache[i] = false;
        }
        iCachePos = -1;
        loadCache();
    }

    private void loadUdic()
    {
        int idat, i = 0;
        char cdat;
        StringBuffer sbDic;
        StringBuffer sbCnt;
        boolean bFirst = true, bCmt = false, bDicWord = true;
        FileConnection fc = null;
        InputStream is = null;
        byte[] ba;
        RecordStore rs = null;

        String fn = "E:/KKJConv/KKJUser.dic";
        try {
            rs = RecordStore.openRecordStore("KKJUdic", false);
            ba = rs.getRecord(1);
            fn = new String(ba, "UTF-8");
        } catch (Exception e) {
        } finally {
            try {
                if (null != rs) rs.closeRecordStore();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }

        iNumUdic = (KKJConv.bNumUdic < 0) ? 127 - KKJConv.bNumUdic : KKJConv.bNumUdic;

//        sUdicErr = "iNumUdic = " + iNumUdic;

        sbDic = new StringBuffer();
        sbCnt = new StringBuffer();
        wordUdic = new String[iNumUdic];
        contUdic = new String[iNumUdic];
        hashUdic = new byte[iNumUdic];
        try {
            fc = (FileConnection)Connector.open("file:///" + fn, Connector.READ);
            if (!fc.exists()) {
                throw new IOException("User Dictionary not found. fn=" + fn);
            }
            is = fc.openInputStream();
            InputStreamReader isr = new InputStreamReader(is, "UTF-8");
            loop_read:
            while (-1 != (idat = isr.read())) {
                cdat = (char)idat;
                switch (cdat) {
                    case 0x0a :
                    case 0x0d :
                        if (sbDic.length() > 0 && sbCnt.length() > 0) {
                            wordUdic[i] = sbDic.toString().trim();
                            contUdic[i] = sbCnt.toString().trim();
                            hashUdic[i] = getHash(wordUdic[i]);
                            i++;
                            if (i >= iNumUdic) break loop_read;
                        }
                        sbDic.delete(0, sbDic.length());
                        sbCnt.delete(0, sbCnt.length());
                        bCmt = false;
                        bFirst = bDicWord = true;
                        break;
                    case '　' :
                    case ' ' :
                        bFirst = bDicWord = false;
                        break;
                    case ';' :
                        if (bFirst) {
                            bCmt = true;
                            bFirst = false;
                        }
                        break;
                    default :
                        if(!bCmt) {
                            if (bDicWord) sbDic.append(cdat);
                            else sbCnt.append(cdat);
                        }
                        bFirst = false;
                }
            }
        } catch (Exception e) {
            sUdicErr = "" + e + ", " + sbDic;
            e.printStackTrace();
        } finally {
            try {
                if (null != is) is.close();
                if (null != fc) fc.close();
            } catch (IOException e) {
            }
        }
    }

    private void loadCache()
    {
        RecordStore rsw = null, rsc = null, rss = null;
        byte[] ba;
        int i, iPos, iWord, iCont;

        try {
            rsw = RecordStore.openRecordStore("kjCache", false);
        } catch (Exception e) {
            loadCache2();
        }
        try {
            ba = rsw.getRecord(1);
            if (0 < ba.length) {
                iPos = iWord = iCont = 0;
                for (i = 0; i < ba.length; i++) {
                    if (0 == ba[i]) {
                        if (i == iPos) break;
                        if (iWord == iCont) {
                            wordCache[iWord] = new String(ba, iPos, i - iPos, enc);
                            hashCache[iWord] = getHash(wordCache[iWord]);
                            iWord++;
                            if (iWord >= iNumCacheEntries) break;
                        } else {
                            contCache[iCont] = new String(ba, iPos, i - iPos, enc);
                            if (contCache[iCont].startsWith("\r")) {
                                stCache[iCont] = true;
                                contCache[iCont] = contCache[iCont].substring(1);
                            } else stCache[iCont] = false;
                            iCont++;
                            if (iCont >= iNumCacheEntries) break;
                        }
                        iPos = i + 1;
                    }
                }
                iCachePos = iCont - 1;
            }
            // statistical data
            ba = new byte[4];
            rss = RecordStore.openRecordStore("statCache", false);
            ba = rss.getRecord(1);
            iCacheHit = ba2int(ba);
            ba = rss.getRecord(2);
            iTotalHit = ba2int(ba);
        } catch (Exception e) {
//            sError = "loadIndex: " + e;
//            e.printStackTrace();
        } finally {
            try {
                if (null != rsw) rsw.closeRecordStore();
                if (null != rss) rss.closeRecordStore();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    private void loadCache2()
    {
        RecordStore rsw = null, rsc = null, rss = null;
        byte[] ba;
        int i;

        try {
            rsw = RecordStore.openRecordStore("wordCache", false);
            rsc = RecordStore.openRecordStore("contCache", false);
            for (i = 0; i < rsw.getNumRecords(); i++) {
                ba = rsw.getRecord(i + 1);
                if (0 == ba.length) break;
                wordCache[i] = new String(ba, enc);
                hashCache[i] = getHash(ba);
                ba = rsc.getRecord(i + 1);
                if (0 == ba.length) break;
                contCache[i] = new String(ba, enc);
            }
            iCachePos = i - 1;
            // statistical data
            ba = new byte[4];
            rss = RecordStore.openRecordStore("statCache", false);
            ba = rss.getRecord(1);
            iCacheHit = ba2int(ba);
            ba = rss.getRecord(2);
            iTotalHit = ba2int(ba);
        } catch (Exception e) {
//            sError = "loadIndex: " + e;
//            e.printStackTrace();
        } finally {
            try {
                if (null != rsw) rsw.closeRecordStore();
                if (null != rsc) rsc.closeRecordStore();
                if (null != rss) rss.closeRecordStore();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        delOldCache();
    }

    private void delOldCache()
    {
        try {
            RecordStore.deleteRecordStore("wordCache");
            RecordStore.deleteRecordStore("contCache");
            sError = "Old Cache was deleted.";
        } catch (Exception e) {
        }
    }

    private int ba2int(byte[] ba)    // ba has to be 4 bytes array
    {
        int i = 0;
        for (int j = 3; j >= 0; j--) {
            i *= 128;
            i += ba[j];
        }
        return i;
    }

    private byte[] int2ba(int i)
    {
        byte [] ba = new byte[4];
        int iWork = i;
        for (int j = 0; j < 4; j++) {
            ba[j] = (byte)(iWork % 128);
            iWork /= 128;
        }
        return ba;
    }

    private byte getHash(String s)
    {
        try {
            byte [] ba = s.getBytes(enc);
            return getHash(ba);
        } catch (UnsupportedEncodingException e) {}
        return (byte)0;
    }

    private byte getHash(byte[] ba)
    {
        if (ba.length < 3) return 0;
        return ba[2];
    }

    public void storeCache()
    {
        byte[] ba;
        byte[] bCache = new byte[iCacheSize];
        String sCwFlag;
        int i, j, ix, iBytes = 0;

        try {
            try {
                RecordStore.deleteRecordStore("kjCache");
            } catch (RecordStoreNotFoundException e) {
            }
            RecordStore rsw = RecordStore.openRecordStore("kjCache", true);
            for (i = 0; i <= iCachePos; i++) {
                ix = indexCache[i];
                ba = wordCache[ix].getBytes(enc);
                if (iCacheSize < iBytes + ba.length + 2) break;
                for (j = 0; j < ba.length; j++) bCache[j + iBytes] = ba[j];
                bCache[iBytes + ba.length] = 0;
                iBytes += ba.length + 1;
                sCwFlag = (stCache[ix]) ? "\r" : "";
                ba = (sCwFlag + contCache[ix]).getBytes(enc);
                if (iCacheSize < iBytes + ba.length + 2) break;
                for (j = 0; j < ba.length; j++) bCache[j + iBytes] = ba[j];
                bCache[iBytes + ba.length] = 0;
                iBytes += ba.length + 1;
            }
            bCache[iBytes] = 0;
            if (iBytes + 1 < iCacheSize) bCache[iBytes + 1] = 0;
            rsw.addRecord(bCache, 0, bCache.length);
            rsw.closeRecordStore();
            // statistical data
            ba = new byte[4];
            try {
                RecordStore.deleteRecordStore("statCache");
            } catch (RecordStoreNotFoundException e) {
            }
            RecordStore rss = RecordStore.openRecordStore("statCache", true);
            ba = int2ba(iCacheHit);
            rss.addRecord(ba, 0, 4);
            ba = int2ba(iTotalHit);
            rss.addRecord(ba, 0, 4);
            rss.closeRecordStore();
        } catch (Exception e) {
            sError = "storeIndex: " + e;
            e.printStackTrace();
        }
    }

    public String cacheStatusReport(char paraSepa)
    {
        int [] ia = new int[256];
        int i = 0, iHashCount = 0, iBytes = 0, iRatio2;
        long lRatio1;
        byte [] ba;
        StringBuffer sb = new StringBuffer();
        try {
            for (i = 0; i < 256; i++) ia[i] = 0;
            for (i = 0; i <= iCachePos; i++) {
                ia[hashCache[i]+128] = 1;
                ba = wordCache[i].getBytes(enc);
                iBytes += ba.length + 1;
                ba = contCache[i].getBytes(enc);
                iBytes += ba.length + 1;
            }
        } catch (Exception e) {
            sb.append("" + hashCache[i]);
            e.printStackTrace();
        }
        for (i = 0; i < 256; i++) iHashCount += ia[i];
        lRatio1 = iCacheHit;
        lRatio1 *= 10000l;
        lRatio1 = (0 == iTotalHit) ? 0l : lRatio1 / (long)iTotalHit;
        iRatio2 = (int)(lRatio1 % 100l);
        lRatio1 /= 100l;

        sb.append("[ Cache Statistical Summary ]" + paraSepa);
        sb.append(" Cache hit ratio : " + lRatio1 + "." + iRatio2 + "%" + paraSepa);
        sb.append(" Total cache hit = " + iCacheHit + paraSepa);
        sb.append(" Total Retrieve = " + iTotalHit + paraSepa);
        sb.append(" Hash Variety : " + iHashCount + paraSepa);
        sb.append(" Number of cache entries = " + (iCachePos + 1) + paraSepa);
        sb.append(" Cache size = " + iBytes + " byte" + paraSepa);
        sb.append(" sError: " + sError + paraSepa);
//        sb.append(" sDebug: " + sbDebug.toString());
        return sb.toString();
    }

    public String printCache(char paraSepa)
    {
        int ix;
        StringBuffer sb = new StringBuffer();

        sb.append("User Dictionary" + paraSepa);
        for (int i = 0; i < iNumUdic; i++) {
            if (null == wordUdic[i]) break;
            sb.append(i + ", " + wordUdic[i] + ", " + contUdic[i] + paraSepa);
        }

        sb.append("Cache Entries" + paraSepa);
        for (int i = 0; i <= iCachePos; i++) {
            ix = indexCache[i];
            sb.append(ix + ", " + hashCache[ix] + ", " + wordCache[ix] + ", " + contCache[ix] + ((stCache[ix])?"*":"") + paraSepa);
        }
        return sb.toString();
    }

    public void kakutei()
    {
        int i, ix = 0;
//        byte hash = getHash(sPre + sWord);

        if (++iTotalHit < 0) iTotalHit = iCacheHit = 0;
        if (-2 == vCurrent.cachePosition) return;        // not enter cache
        if (0 <= (i = vCurrent.cachePosition)) {        // Cache hit
            if (stCache[indexCache[i]]) hitCacheIndex(i);
            else hitCacheIndex2(i);
            if (++iCacheHit < 0) iCacheHit = iTotalHit = 0;
            return;
        }
        if (iCachePos < iNumCacheEntries - 1) {            // No cache hit
            iCachePos++;
            ix = iCachePos;
            indexCache[iCachePos] = (byte)iCachePos;
        } else {
            ix = indexCache[iCachePos];
        }
        wordCache[ix] = vCurrent.cacheYomi;
        contCache[ix] = vCurrent.cacheWord;
        hashCache[ix] = getHash(vCurrent.cacheYomi);
        stCache[ix] = false;
        hitCacheIndex2(iCachePos);
    }

    public void kakutei(String yomi, String word)
    {
        int i, ix = 0;
        byte hash = getHash(yomi);

        if (++iTotalHit < 0) iTotalHit = iCacheHit = 0;

        if (0 <= vCurrent.cachePosition && hash == getHash(vCurrent.cacheYomi)) {
            if (0 == yomi.compareTo(vCurrent.cacheYomi) && 0 == word.compareTo(vCurrent.cacheWord)) {
                i = vCurrent.cachePosition;            // this may not happen
//                ix = indexCache[i];
                hitCacheIndex(i);
                if (++iCacheHit < 0) iCacheHit = iTotalHit = 0;
                return;
            }
        }
        if (iCachePos < iNumCacheEntries - 1) {
            iCachePos++;
            ix = iCachePos;
            indexCache[iCachePos] = (byte)iCachePos;
        } else {
            ix = indexCache[iCachePos];
        }
        wordCache[ix] = yomi;
        contCache[ix] = word;
        hashCache[ix] = hash;
        stCache[ix] = true;
        hitCacheIndex(iCachePos);
    }

    public void kakutei(int seq)
    {
        vCurrent = v;
        while (true) {
            if (seq == vCurrent.seq) {
                kakutei();
                break;
            }
            if (null == vCurrent.next) break;
            vCurrent = vCurrent.next;
            if (0 == vCurrent.seq) break;
        }
    }

    public void hitCacheIndex2(int indx)
    {
        int i, iTop = iNumStCache, ix = indexCache[indx];

        for (i = 0; i < iNumStCache; i++) {
            if (!stCache[indexCache[i]]) {
                iTop = i;
                break;
            }
        }

        for (i = indx; i > iTop; i--) {
            indexCache[i] = indexCache[i - 1];
        }
        indexCache[iTop] = (byte)ix;
    }

    public void hitCacheIndex(int indx)
    {
        int ix = indexCache[indx];

        for (int i = indx; i > 0; i--) {
            indexCache[i] = indexCache[i - 1];
        }
        indexCache[0] = (byte)ix;
    }

    public int getAll()
    {
        while (v != vCurrent) getNext();
        return v.prev.seq + 1;
    }

    public int getCurrentSeq()
    {
        return vCurrent.seq;
    }

    public String getFirst()
    {
        return v.word;
    }

    public String getNext()
    {
        Vect vWork;

        if (null != vCurrent.next) {
            vCurrent = vCurrent.next;
        } else {
            if (null == (vWork = searchDict()))    {
                if (null == (vWork = setWord2())) {
                    vCurrent = v;
                    v.prev = v.getLast();
                }
                else vCurrent = vWork;
            }
            else vCurrent = vWork;
        }
        return vCurrent.word;
    }

    public String getPrev()
    {
        if (null != vCurrent.prev) {
            vCurrent = vCurrent.prev;
        }
        return vCurrent.word;
    }

    public Vect setWord2()
    {
        Vect v = null;

        if ('お' == sWord.charAt(0) && 0 == sPre.compareTo("") && 1 < sWord.length()) {
            sPre = "お";
            sWord = sWord.substring(1);
            cIni = sWord.charAt(0);
            idx = getIndx(cIni);
            try {
//                sbDebug.append("setWord2 in.close/open ");
                in.close();
                in = getClass().getResourceAsStream(sFileName + "." + idx);
                isn = new InputStreamReader(in, enc);
            } catch (IOException e) {
                sError = "setWord2: " + e;
                e.printStackTrace();
            }
            v = searchDict();
        }

        return v;
    }

    public void setWord(String word, String roma)
    {
        bCacheMode = true;
        sPre = "";
        sWord = word;
        cIni = word.charAt(0);
        if (0 != roma.compareTo("")) {
            v.word = roma;
            v.cachePosition = -2;
            v.prev = v.next = null;
            vCurrent = v;
            setZenkaku(roma);
            bFirstV = false;
        } else bFirstV = true;
        setHanKana(word);
        setZenKana(word);
        setHiragana(word);
        vBase = vCurrent;
        idx = getIndx(cIni);
        bNeedOpenDic = true;
        try {
            if (null != in) {
//                sbDebug.append("setWord close ");
                in.close();
                in = null;
            }
        } catch (IOException e) {
            sError = "setWord in.close: " + e;
            e.printStackTrace();
        }
    }

    private void setHiragana(String word)
    {
        Vect vWork, vWork2;
        if (bFirstV) {
            v.word = v.cacheWord = word;
            v.cacheYomi = word;
            v.cachePosition = -2;
            v.prev = v.next = null;
            vCurrent = v;
            bFirstV = false;
        } else {
            vWork = vCurrent.getLast();
            vWork2 = vWork.next = new Vect(vWork);
            vWork2.word = vWork2.cacheWord = word;
            vWork2.cacheYomi = word;
            vWork2.cachePosition = -2;
            vCurrent = vWork2;
        }
    }

    private void setZenKana(String word)
    {
        Vect vWork, vWork2;
        char c, r;
        int i;
        boolean bFlg = false;
        StringBuffer sbWork = new StringBuffer();

        for (i = 0; i < word.length(); i++) {
            c = word.charAt(i);
            switch (c) {
                case 'あ' : r = 'ア'; break;
                case 'ぁ' : r = 'ァ'; break;
                case 'い' : r = 'イ'; break;
                case 'ぃ' : r = 'ィ'; break;
                case 'う' : r = 'ウ'; break;
                case 'ぅ' : r = 'ゥ'; break;
                case 'え' : r = 'エ'; break;
                case 'ぇ' : r = 'ェ'; break;
                case 'お' : r = 'オ'; break;
                case 'ぉ' : r = 'ォ'; break;
                case 'か' : r = 'カ'; break;
                case 'が' : r = 'ガ'; break;
                case 'き' : r = 'キ'; break;
                case 'ぎ' : r = 'ギ'; break;
                case 'く' : r = 'ク'; break;
                case 'ぐ' : r = 'グ'; break;
                case 'け' : r = 'ケ'; break;
                case 'げ' : r = 'ゲ'; break;
                case 'こ' : r = 'コ'; break;
                case 'ご' : r = 'ゴ'; break;
                case 'さ' : r = 'サ'; break;
                case 'ざ' : r = 'ザ'; break;
                case 'し' : r = 'シ'; break;
                case 'じ' : r = 'ジ'; break;
                case 'す' : r = 'ス'; break;
                case 'ず' : r = 'ズ'; break;
                case 'せ' : r = 'セ'; break;
                case 'ぜ' : r = 'ゼ'; break;
                case 'そ' : r = 'ソ'; break;
                case 'ぞ' : r = 'ゾ'; break;
                case 'た' : r = 'タ'; break;
                case 'だ' : r = 'ダ'; break;
                case 'ち' : r = 'チ'; break;
                case 'ぢ' : r = 'ヂ'; break;
                case 'つ' : r = 'ツ'; break;
                case 'っ' : r = 'ッ'; break;
                case 'づ' : r = 'ヅ'; break;
                case 'て' : r = 'テ'; break;
                case 'で' : r = 'デ'; break;
                case 'と' : r = 'ト'; break;
                case 'ど' : r = 'ド'; break;
                case 'な' : r = 'ナ'; break;
                case 'に' : r = 'ニ'; break;
                case 'ぬ' : r = 'ヌ'; break;
                case 'ね' : r = 'ネ'; break;
                case 'の' : r = 'ノ'; break;
                case 'は' : r = 'ハ'; break;
                case 'ば' : r = 'バ'; break;
                case 'ぱ' : r = 'パ'; break;
                case 'ひ' : r = 'ヒ'; break;
                case 'び' : r = 'ビ'; break;
                case 'ぴ' : r = 'ピ'; break;
                case 'ふ' : r = 'フ'; break;
                case 'ぶ' : r = 'ブ'; break;
                case 'ぷ' : r = 'プ'; break;
                case 'へ' : r = 'ヘ'; break;
                case 'べ' : r = 'ベ'; break;
                case 'ぺ' : r = 'ペ'; break;
                case 'ほ' : r = 'ホ'; break;
                case 'ぼ' : r = 'ボ'; break;
                case 'ぽ' : r = 'ポ'; break;
                case 'ま' : r = 'マ'; break;
                case 'み' : r = 'ミ'; break;
                case 'む' : r = 'ム'; break;
                case 'め' : r = 'メ'; break;
                case 'も' : r = 'モ'; break;
                case 'や' : r = 'ヤ'; break;
                case 'ゃ' : r = 'ャ'; break;
                case 'ゆ' : r = 'ユ'; break;
                case 'ゅ' : r = 'ュ'; break;
                case 'よ' : r = 'ヨ'; break;
                case 'ょ' : r = 'ョ'; break;
                case 'ら' : r = 'ラ'; break;
                case 'り' : r = 'リ'; break;
                case 'る' : r = 'ル'; break;
                case 'れ' : r = 'レ'; break;
                case 'ろ' : r = 'ロ'; break;
                case 'わ' : r = 'ワ'; break;
                case 'を' : r = 'ヲ'; break;
                case 'ん' : r = 'ン'; break;
                default   : r = c;
            }
            if (r != c) bFlg = true;
            sbWork.append(r);
        }
        if (bFlg) {
            if (bFirstV) {
                v.word = v.cacheWord = sbWork.toString();
                v.cacheYomi = word;
                v.cachePosition = -1;
                v.prev = v.next = null;
                vCurrent = v;
                bFirstV = false;
            } else {
                vWork = vCurrent.getLast();
                vWork2 = vWork.next = new Vect(vWork);
                vWork2.word = vWork2.cacheWord = sbWork.toString();
                vWork2.cacheYomi = word;
                vWork2.cachePosition = -1;
                vCurrent = vWork2;
            }
        }
    }

    private void setHanKana(String word)
    {
        Vect vWork, vWork2;
        char c;
        String r;
        int i;
        boolean bFlg = false, bFlg2;
        StringBuffer sbWork = new StringBuffer();

        for (i = 0; i < word.length(); i++) {
            c = word.charAt(i);
            bFlg2 = false;
            switch (c) {
                case 'あ' : r ="ｱ"; break;
                case 'ぁ' : r ="ｧ"; break;
                case 'い' : r ="ｲ"; break;
                case 'ぃ' : r ="ｨ"; break;
                case 'う' : r ="ｳ"; break;
                case 'ぅ' : r ="ｩ"; break;
                case 'え' : r ="ｴ"; break;
                case 'ぇ' : r ="ｪ"; break;
                case 'お' : r ="ｵ"; break;
                case 'ぉ' : r ="ｫ"; break;
                case 'か' : r ="ｶ"; break;
                case 'が' : r ="ｶﾞ"; break;
                case 'き' : r ="ｷ"; break;
                case 'ぎ' : r ="ｷﾞ"; break;
                case 'く' : r ="ｸ"; break;
                case 'ぐ' : r ="ｸﾞ"; break;
                case 'け' : r ="ｹ"; break;
                case 'げ' : r ="ｹﾞ"; break;
                case 'こ' : r ="ｺ"; break;
                case 'ご' : r ="ｺﾞ"; break;
                case 'さ' : r ="ｻ"; break;
                case 'ざ' : r ="ｻﾞ"; break;
                case 'し' : r ="ｼ"; break;
                case 'じ' : r ="ｼﾞ"; break;
                case 'す' : r ="ｽ"; break;
                case 'ず' : r ="ｽﾞ"; break;
                case 'せ' : r ="ｾ"; break;
                case 'ぜ' : r ="ｾﾞ"; break;
                case 'そ' : r ="ｿ"; break;
                case 'ぞ' : r ="ｿﾞ"; break;
                case 'た' : r ="ﾀ"; break;
                case 'だ' : r ="ﾀﾞ"; break;
                case 'ち' : r ="ﾁ"; break;
                case 'ぢ' : r ="ﾁﾞ"; break;
                case 'つ' : r ="ﾂ"; break;
                case 'っ' : r ="ｯ"; break;
                case 'づ' : r ="ﾂﾞ"; break;
                case 'て' : r ="ﾃ"; break;
                case 'で' : r ="ﾃﾞ"; break;
                case 'と' : r ="ﾄ"; break;
                case 'ど' : r ="ﾄﾞ"; break;
                case 'な' : r ="ﾅ"; break;
                case 'に' : r ="ﾆ"; break;
                case 'ぬ' : r ="ﾇ"; break;
                case 'ね' : r ="ﾈ"; break;
                case 'の' : r ="ﾉ"; break;
                case 'は' : r ="ﾊ"; break;
                case 'ば' : r ="ﾊﾞ"; break;
                case 'ぱ' : r ="ﾊﾟ"; break;
                case 'ひ' : r ="ﾋ"; break;
                case 'び' : r ="ﾋﾞ"; break;
                case 'ぴ' : r ="ﾋﾟ"; break;
                case 'ふ' : r ="ﾌ"; break;
                case 'ぶ' : r ="ﾌﾞ"; break;
                case 'ぷ' : r ="ﾌﾟ"; break;
                case 'へ' : r ="ﾍ"; break;
                case 'べ' : r ="ﾍﾞ"; break;
                case 'ぺ' : r ="ﾍﾟ"; break;
                case 'ほ' : r ="ﾎ"; break;
                case 'ぼ' : r ="ﾎﾞ"; break;
                case 'ぽ' : r ="ﾎﾟ"; break;
                case 'ま' : r ="ﾏ"; break;
                case 'み' : r ="ﾐ"; break;
                case 'む' : r ="ﾑ"; break;
                case 'め' : r ="ﾒ"; break;
                case 'も' : r ="ﾓ"; break;
                case 'や' : r ="ﾔ"; break;
                case 'ゃ' : r ="ｬ"; break;
                case 'ゆ' : r ="ﾕ"; break;
                case 'ゅ' : r ="ｭ"; break;
                case 'よ' : r ="ﾖ"; break;
                case 'ょ' : r ="ｮ"; break;
                case 'ら' : r ="ﾗ"; break;
                case 'り' : r ="ﾘ"; break;
                case 'る' : r ="ﾙ"; break;
                case 'れ' : r ="ﾚ"; break;
                case 'ろ' : r ="ﾛ"; break;
                case 'わ' : r ="ﾜ"; break;
                case 'を' : r ="ｦ"; break;
                case 'ん' : r ="ﾝ"; break;
                case 'ー' : r ="ｰ"; break;
                default   : r = new Character(c).toString();
                            bFlg2 = true;
            }
            sbWork.append(r);
            if (!bFlg2) bFlg = true;
        }

        if (bFlg) {
            if (bFirstV) {
                v.word = v.cacheWord = sbWork.toString();
                v.cacheYomi = word;
                v.cachePosition = -1;
                v.prev = v.next = null;
                vCurrent = v;
                bFirstV = false;
            } else {
                vWork = vCurrent.getLast();
                vWork2 = vWork.next = new Vect(vWork);
                vWork2.word = vWork2.cacheWord = sbWork.toString();
                vWork2.cacheYomi = word;
                vWork2.cachePosition = -1;
                vCurrent = vWork2;
            }
        }
    }

    private void setZenkaku(String roma)
    {
        Vect vWork, vWork2;
        char c, r;
        int i;
        boolean bFlg = false;
        StringBuffer sbWork = new StringBuffer();

        for (i = 0; i < roma.length(); i++) {
            c = roma.charAt(i);
            switch (c) {
                case '!' : r = '！'; break;
                case '"' : r = '”'; break;
                case '#' : r = '＃'; break;
                case '$' : r = '＄'; break;
                case '%' : r = '％'; break;
                case '&' : r = '＆'; break;
                case '\'' : r = '’'; break;
                case '(' : r = '（'; break;
                case ')' : r = '）'; break;
                case '*' : r = '＊'; break;
                case '+' : r = '＋'; break;
                case ',' : r = '，'; break;
                case '-' : r = '－'; break;
                case '.' : r = '．'; break;
                case '/' : r = '／'; break;
                case '0' : r = '０'; break;
                case '1' : r = '１'; break;
                case '2' : r = '２'; break;
                case '3' : r = '３'; break;
                case '4' : r = '４'; break;
                case '5' : r = '５'; break;
                case '6' : r = '６'; break;
                case '7' : r = '７'; break;
                case '8' : r = '８'; break;
                case '9' : r = '９'; break;
                case ':' : r = '：'; break;
                case ';' : r = '；'; break;
                case '<' : r = '＜'; break;
                case '=' : r = '＝'; break;
                case '>' : r = '＞'; break;
                case '?' : r = '？'; break;
                case '@' : r = '＠'; break;
                case 'A' : r = 'Ａ'; break;
                case 'B' : r = 'Ｂ'; break;
                case 'C' : r = 'Ｃ'; break;
                case 'D' : r = 'Ｄ'; break;
                case 'E' : r = 'Ｅ'; break;
                case 'F' : r = 'Ｆ'; break;
                case 'G' : r = 'Ｇ'; break;
                case 'H' : r = 'Ｈ'; break;
                case 'I' : r = 'Ｉ'; break;
                case 'J' : r = 'Ｊ'; break;
                case 'K' : r = 'Ｋ'; break;
                case 'L' : r = 'Ｌ'; break;
                case 'M' : r = 'Ｍ'; break;
                case 'N' : r = 'Ｎ'; break;
                case 'O' : r = 'Ｏ'; break;
                case 'P' : r = 'Ｐ'; break;
                case 'Q' : r = 'Ｑ'; break;
                case 'R' : r = 'Ｒ'; break;
                case 'S' : r = 'Ｓ'; break;
                case 'T' : r = 'Ｔ'; break;
                case 'U' : r = 'Ｕ'; break;
                case 'V' : r = 'Ｖ'; break;
                case 'W' : r = 'Ｗ'; break;
                case 'X' : r = 'Ｘ'; break;
                case 'Y' : r = 'Ｙ'; break;
                case 'Z' : r = 'Ｚ'; break;
                case '[' : r = '［'; break;
                case '\\' : r = '￥'; break;
                case ']' : r = '］'; break;
                case '^' : r = '＾'; break;
                case '_' : r = '＿'; break;
                case '`' : r = '‘'; break;
                case 'a' : r = 'ａ'; break;
                case 'b' : r = 'ｂ'; break;
                case 'c' : r = 'ｃ'; break;
                case 'd' : r = 'ｄ'; break;
                case 'e' : r = 'ｅ'; break;
                case 'f' : r = 'ｆ'; break;
                case 'g' : r = 'ｇ'; break;
                case 'h' : r = 'ｈ'; break;
                case 'i' : r = 'ｉ'; break;
                case 'j' : r = 'ｊ'; break;
                case 'k' : r = 'ｋ'; break;
                case 'l' : r = 'ｌ'; break;
                case 'm' : r = 'ｍ'; break;
                case 'n' : r = 'ｎ'; break;
                case 'o' : r = 'ｏ'; break;
                case 'p' : r = 'ｐ'; break;
                case 'q' : r = 'ｑ'; break;
                case 'r' : r = 'ｒ'; break;
                case 's' : r = 'ｓ'; break;
                case 't' : r = 'ｔ'; break;
                case 'u' : r = 'ｕ'; break;
                case 'v' : r = 'ｖ'; break;
                case 'w' : r = 'ｗ'; break;
                case 'x' : r = 'ｘ'; break;
                case 'y' : r = 'ｙ'; break;
                case 'z' : r = 'ｚ'; break;
                case '{' : r = '｛'; break;
                case '|' : r = '｜'; break;
                case '}' : r = '｝'; break;
                case '~' : r = '～'; break;
                default: r = '　';
            }
            sbWork.append(r);
            if (r != '　') bFlg = true;
        }

        if (bFlg) {
            vWork = vCurrent.getLast();
            vWork2 = vWork.next = new Vect(vWork);
            vWork2.word = sbWork.toString();
            vWork2.cachePosition = -2;
            vCurrent = vWork2;
        }
    }

    private Vect searchDict()
    {
        Vect vFirst = null, vWork, vWork2 = vCurrent;
        int idat, i, ix;
        byte bHash;
        boolean bCacheHit = false;
        char cdat, cdat2;
        boolean bDic = true, bHit = false;;
        StringBuffer sbDic = new StringBuffer();
        StringBuffer sbCnt = new StringBuffer();
        String sWork;

        if (bCacheMode) {
            bHash = getHash(sWord);
            if (1 == KKJConv.bUserDict) {
                for (i = 0; i < iNumUdic; i++) {
                    if (null == wordUdic[i] || null == contUdic[i]) break;
                    if (bHash == hashUdic[i]) {
                        if (sWord.startsWith(wordUdic[i])) {
                            vWork = vWork2.getLast();
                            vWork2 = vWork.next = new Vect(vWork);
                            if (null == vFirst) vFirst = vWork2;
                            sRemain = sWord.substring(wordUdic[i].length());
                            vWork2.word = sPre + contUdic[i].toString() + sRemain;
                            //vWork2.word = wordUdic[i] + ">" + contUdic[i].toString();
                            vWork2.cacheWord = sPre + contUdic[i].toString();
                            vWork2.cacheYomi = wordUdic[i];
                            vWork2.cachePosition = -2;
                            bCacheHit = true;
                        }
                    }
                }
            }
            for (i = 0; i <= iCachePos; i++) {
                ix = indexCache[i];
                if (bHash == hashCache[ix]) {
                    if (sWord.startsWith(wordCache[ix])) {
                        sRemain = sWord.substring(wordCache[ix].length());
                        sWork = sPre + contCache[ix].toString() + sRemain;
                        if (checkDup(sWork)) {
                            vWork = vWork2.getLast();
                            vWork2 = vWork.next = new Vect(vWork);
                            if (null == vFirst) vFirst = vWork2;
//                            sRemain = sWord.substring(wordCache[ix].length());
                            vWork2.word = sWork;
                            vWork2.cacheWord = sPre + contCache[ix].toString();
                            vWork2.cacheYomi = wordCache[ix];
                            vWork2.cachePosition = i;
                            bCacheHit = true;
                        }
                    }
                }
            }
            bCacheMode = false;
        }
        if (!bCacheHit) {
            try {
                if (bNeedOpenDic) {
//                    sbDebug.append("searchDict open ");
                    in = getClass().getResourceAsStream(sFileName + "." + idx);
                    isn = new InputStreamReader(in, "UTF-8");
                    bNeedOpenDic = false;
                }
                while (-1 != (idat = isn.read())) {
                    cdat = (char)idat;
                    switch (cdat) {
                        case 0x0a :        // this is valis because of UTF-8 !!
                            bDic = true;
                            sbDic.delete(0, sbDic.length());
                            sbCnt.delete(0, sbCnt.length());
                            break;
                        case ' ' :
                            bDic = false;
                            bHit = dictMatch(sbDic.toString());
                            break;
                        case '/' :
                            if (bHit && 0 < sbCnt.length()) {
                                sWork = sPre + sbCnt.toString() + sRemain;
                                if (checkDup(sWork)) {
                                    vWork = vWork2.getLast();
                                    vWork2 = vWork.next = new Vect(vWork);
                                    if (null == vFirst) vFirst = vWork2;
                                    vWork2.word = sWork;
                                    if (0 < sRemain.length()) {
                                        cdat2 = sRemain.charAt(0);
                                        if (0 > sSetuzokusi.indexOf(cdat2)) {
                                            vWork2.cacheWord = sPre + sbCnt.toString() + cdat2;
                                            vWork2.cacheYomi = sPre + sWord.substring(0, sWord.length() - sRemain.length() + 1);
                                        } else {
                                            vWork2.cacheWord = sPre + sbCnt.toString();
                                            vWork2.cacheYomi = sPre + sWord.substring(0, sWord.length() - sRemain.length());
                                        }
                                    } else {
                                        vWork2.cacheWord = sWork;
                                        vWork2.cacheYomi = sPre + sWord;
                                    }
                                    vWork2.cachePosition = -1;
                                }
                                sbCnt.delete(0, sbCnt.length());
                            }
                            break;
                        default :
                            if (bDic) sbDic.append(cdat);
                            else {
                                if (bHit) sbCnt.append(cdat);
                            }
                    }
                }
            } catch (IOException e) {
                sError = "searchDict: " + e;
                e.printStackTrace();
            }
        }
        return vFirst;
    }

    private boolean checkDup(String sWork)
    {
        Vect vx, vy;

        vx = vBase.next;
        while (vx != null) {
            if (0 == vx.word.compareTo(sWork)) return false; //
            vx = vx.next;
            if (vx == v) break;
        }
        return true;
    }

    private boolean dictMatch(String sDic)
    {
        String sTemp = "";
        boolean bFlg = false;

        char cLast = sDic.charAt(sDic.length() - 1);
        if ('a' <= cLast && cLast <= 'z') {
            if (sDic.length() <= sWord.length()) {
                sTemp = sDic.substring(0, sDic.length() - 1);
                if (sWord.startsWith(sTemp)) {
                    bFlg = (cLast == getIni(sWord.substring(sTemp.length())));
                }
            }
        } else {
            sTemp = sDic;
            bFlg = (sWord.startsWith(sTemp));
//            bFlg = (0 == sWord.compareTo(sTemp));
        }
        if (bFlg) {
            sRemain = sWord.substring(sTemp.length());
        }
        return bFlg;
    }

    private char getIni(String sWord)
    {
        char c = ' ';
        char cini = sWord.charAt(0);
        if ('っ' == cini) cini = sWord.charAt(1);
        switch (cini) {
            case 'あ' : c = 'a'; break;
            case 'い' : c = 'i'; break;
            case 'う' : c = 'u'; break;
            case 'え' : c = 'e'; break;
            case 'お' : c = 'o'; break;
            case 'か' :
            case 'き' :
            case 'く' :
            case 'け' :
            case 'こ' : c = 'k'; break;
            case 'が' :
            case 'ぎ' :
            case 'ぐ' :
            case 'げ' :
            case 'ご' : c = 'g'; break;
            case 'さ' :
            case 'し' :
            case 'す' :
            case 'せ' :
            case 'そ' : c = 's'; break;
            case 'ざ' :
            case 'じ' :
            case 'ず' :
            case 'ぜ' :
            case 'ぞ' : c = 'z'; break;
            case 'た' :
            case 'ち' :
            case 'つ' :
            case 'て' :
            case 'と' : c = 't'; break;
            case 'だ' :
            case 'ぢ' :
            case 'づ' :
            case 'で' :
            case 'ど' : c = 'd'; break;
            case 'な' :
            case 'に' :
            case 'ぬ' :
            case 'ね' :
            case 'の' : c = 'n'; break;
            case 'は' :
            case 'ひ' :
            case 'ふ' :
            case 'へ' :
            case 'ほ' : c = 'h'; break;
            case 'ば' :
            case 'び' :
            case 'ぶ' :
            case 'べ' :
            case 'ぼ' : c = 'b'; break;
            case 'ぱ' :
            case 'ぴ' :
            case 'ぷ' :
            case 'ぺ' :
            case 'ぽ' : c = 'p'; break;
            case 'ま' :
            case 'み' :
            case 'む' :
            case 'め' :
            case 'も' : c = 'm'; break;
            case 'や' :
            case 'ゆ' :
            case 'よ' : c = 'y'; break;
            case 'ら' :
            case 'り' :
            case 'る' :
            case 'れ' :
            case 'ろ' : c = 'r'; break;
            case 'わ' :
            case 'を' : c = 'w'; break;
            case 'ん' : c = 'n'; break;
            default   : c = ' ';
        }

        return c;
    }

    private boolean loadIndex()
    {
        byte[] ba = new byte[4];
        int iWork;
        boolean bFlag = true;
        RecordStore rsv = null;

        try {
            rsv = RecordStore.openRecordStore("dicVer", false);
            ba = rsv.getRecord(1);
            if (1 == ba[2]) bCN = true;
            if (dicVersion != ba[0] || dicType != ba[1]) {
                rsv.closeRecordStore();
                return false;
            }
        } catch (Exception e) {
//            sError = "loadIndex: " + e;
//            e.printStackTrace();
            bFlag = false;
        } finally {
            try {
                if (null != rsv) rsv.closeRecordStore();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return bFlag;
    }

    public void storeIndex()
    {
        byte[] ba = new byte[4];
        //byte[] bIndex = new byte[48 * 4];
        int iWork;

        try {
            try {
                RecordStore.deleteRecordStore("dicVer");
            } catch (RecordStoreNotFoundException e) {
            }
            try {
                RecordStore.deleteRecordStore("dicIndex");
            } catch (RecordStoreNotFoundException e) {
            }
            RecordStore rsv = RecordStore.openRecordStore("dicVer", true);
            ba[0] = dicVersion;
            ba[1] = dicType;
            if (bCN) ba[2] = 1;
            else ba[2] = 0;
            ba[3] = 0;
            rsv.addRecord(ba, 0, 4);
            rsv.closeRecordStore();
        } catch (Exception e) {
            sError = "storeIndex: " + e;
            e.printStackTrace();
        }
    }

    private int getIndx(char cdat)
    {
        int pos;

        switch (cdat) {
            case ';'  : pos = -1; break;
            case 'あ' : pos = 45; break;
            case 'い' : pos = 44; break;
            case 'う' : pos = 43; break;
            case 'え' : pos = 42; break;
            case 'お' : pos = 41; break;
            case 'か' :
            case 'が' : pos = 40; break;
            case 'き' :
            case 'ぎ' : pos = 39; break;
            case 'く' :
            case 'ぐ' : pos = 38; break;
            case 'け' :
            case 'げ' : pos = 37; break;
            case 'こ' :
            case 'ご' : pos = 36; break;
            case 'さ' :
            case 'ざ' : pos = 35; break;
            case 'し' :
            case 'じ' : pos = 34; break;
            case 'す' :
            case 'ず' : pos = 33; break;
            case 'せ' :
            case 'ぜ' : pos = 32; break;
            case 'そ' :
            case 'ぞ' : pos = 31; break;
            case 'た' :
            case 'だ' : pos = 30; break;
            case 'ち' :
            case 'ぢ' : pos = 29; break;
            case 'つ' :
            case 'づ' : pos = 28; break;
            case 'て' :
            case 'で' : pos = 27; break;
            case 'と' :
            case 'ど' : pos = 26; break;
            case 'な' : pos = 25; break;
            case 'に' : pos = 24; break;
            case 'ぬ' : pos = 23; break;
            case 'ね' : pos = 22; break;
            case 'の' : pos = 21; break;
            case 'は' :
            case 'ば' :
            case 'ぱ' : pos = 20; break;
            case 'ひ' :
            case 'び' :
            case 'ぴ' : pos = 19; break;
            case 'ふ' :
            case 'ぶ' :
            case 'ぷ' : pos = 18; break;
            case 'へ' :
            case 'べ' :
            case 'ぺ' : pos = 17; break;
            case 'ほ' :
            case 'ぼ' :
            case 'ぽ' : pos = 16; break;
            case 'ま' : pos = 15; break;
            case 'み' : pos = 14; break;
            case 'む' : pos = 13; break;
            case 'め' : pos = 12; break;
            case 'も' : pos = 11; break;
            case 'や' : pos = 10; break;
            case 'ゆ' : pos = 9; break;
            case 'よ' : pos = 8; break;
            case 'ら' : pos = 7; break;
            case 'り' : pos = 6; break;
            case 'る' : pos = 5; break;
            case 'れ' : pos = 4; break;
            case 'ろ' : pos = 3; break;
            case 'わ' : pos = 2; break;
            case 'を' :
            case 'ん' : pos = 1; break;
            default   : pos = 46; break;
        }
        return pos;
    }
}
